<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="模板名称" prop="templateName">
        <el-input v-model="formData.templateName" placeholder="请输入模板名称" />
      </el-form-item>
      <el-form-item label="薪资项目" prop="value">
        <el-checkbox-group v-model="formData.value" class="w-80">
          <el-checkbox
            v-for="item in salaryOptionDefaultList"
            :key="item.code"
            :value="item.code"
          >
            {{ item.name }}
          </el-checkbox>
        </el-checkbox-group>
      </el-form-item>
<!--      <el-form-item label="是否默认" prop="isDefault">-->
<!--        <el-select v-model="formData.isDefault" placeholder="请选择是否默认">-->
<!--          <el-option-->
<!--            v-for="dict in getIntDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"-->
<!--            :key="dict.value"-->
<!--            :label="dict.label"-->
<!--            :value="dict.value"-->
<!--          />-->
<!--        </el-select>-->
<!--      </el-form-item>-->
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { SalaryChangeTemplateApi, SalaryChangeTemplate } from '@/api/hr/salarychangetemplate'
import {SalaryOptionApi, SalaryOption, SalaryOptionSimpleVO} from '@/api/hr/salaryoption'
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";

/** 调薪模板 表单 */
defineOptions({ name: 'SalaryChangeTemplateForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  templateName: undefined,
  isDefault: undefined,
  value: [],
  item: undefined,
})
const salaryOptionDefaultList = ref<SalaryOptionSimpleVO[]>([]) // 树形结构
const formRules = reactive({
  templateName: [{ required: true, message: '模板名称不能为空', trigger: 'blur' }],
  isDefault: [{ required: true, message: '是否默认 0 否 1 是不能为空', trigger: 'blur' }],
  value: [{ required: true, message: '值不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  salaryOptionDefaultList.value = await SalaryOptionApi.queryChangeSalaryOption()
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await SalaryChangeTemplateApi.getSalaryChangeTemplate(id)
      // 提取 code 数组
      formData.value.value = formData.value.value.map(item => item.code) as unknown as number[]
    } finally {
      formLoading.value = false
    }
  }

}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const selectedItems = salaryOptionDefaultList.value
      .filter(item => formData.value.value.includes(item.code)) // 筛选选中的项
      .map(item => ({
        name: item.name,
        code: item.code
      })) // 只保留 name 和 code 字段

    // 构造最终要提交的数据
    const data: SalaryChangeTemplate = {
      id: formData.value.id,
      templateName: formData.value.templateName,
      value: selectedItems // 这就是 [{ name: '岗位工资', code: 10102 }, ...]
    }
    if (formType.value === 'create') {
      await SalaryChangeTemplateApi.setChangeTemplate(data)
      message.success(t('common.createSuccess'))
    } else {
      await SalaryChangeTemplateApi.setChangeTemplate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    templateName: undefined,
    isDefault: undefined,
    value: undefined,
  }
  formRef.value?.resetFields()
}
/** 初始化 */

onMounted(async () => {

})
</script>
